//
//  DotEmuChannelViewController.h
//  DotEmuChannel
//
//  Created by DotEmu on 27/09/10.
//  Copyright DotEmu 2010. All rights reserved.
//  Author: Guillaume SIORAK
//  Email: guillaume.siorak@dotemu.com
//

#import <UIKit/UIKit.h>

typedef struct 
{
	int       gameID;
	NSString* gameName;
	UIImage*  gameImg;
	NSString* gameDesc;	
	NSString* gameURL;
} DEGames;

@interface DotEmuChannelViewController : UIViewController<UIScrollViewDelegate,NSXMLParserDelegate,UITextFieldDelegate,UIAlertViewDelegate>
{
	//OUTLETS
	IBOutlet UIImageView*				_background;
	IBOutlet UIScrollView*				_scrollView;
	IBOutlet UIActivityIndicatorView*	_activityIndicator;	
	IBOutlet UIActivityIndicatorView*	_emailActivityIndicator;	
	IBOutlet UITextField*				_emailToGet;
	IBOutlet UIButton*					_back;	
	IBOutlet UIButton*					_sendEmail;
	IBOutlet UIButton*					_FB;
	IBOutlet UIButton*					_twitter;	
	IBOutlet UILabel*					_benefitsL;

	//ATTRIBUTES
	UIButton*		_GamesB[50];
	UIImageView*	_GamesI[50];
	UITextView*		_GamesL[50];
	
	//GAMES
	int     GAMES_TOTAL;
	int     currentID;
	DEGames _Games[50];
	int		decrem;
	
	//XML
	NSMutableData*		storeData;	
	NSMutableData*		emailData;	
	NSURLConnection*	_submitConnection;
	bool				emailNSURL;	
	int					responseURL;
	
	//LANGUAGES
	NSArray*  _languages;
	NSString* _preferredLang;
	NSString* _Lang;	
}

//ACTIONS
- (IBAction) backButtonClicked:(id)sender;
- (IBAction) gameClicked:(id)sender;
- (IBAction) submitClicked:(id)sender;
- (IBAction) FBClicked:(id)sender;
- (IBAction) TwitterClicked:(id)sender;

//METHODS
- (void) loadGames:(int)iid;
- (void) clearGames:(int)iid;

//DELEGATES
- (BOOL) textFieldShouldReturn:(UITextField *)textField;
- (void) textFieldDidBeginEditing:(UITextField *)textField;

@end

