//
//  creditsViewController.m
//  scummvm
//
//  Created by DotEmu on 18/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "creditsViewController.h"

extern int idSoundSFX;

@implementation creditsViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"creditsViewController viewDidLoad");
	bWarning = false;
	
	page = 0;
	nextP.exclusiveTouch = YES;
	nextP.enabled = YES;
	
	dotemuGPL.exclusiveTouch = YES;
	dotemuGPL.enabled = YES;
	dotemuGPL.hidden = YES;	
	
	scummVM.exclusiveTouch = YES;
	scummVM.enabled = YES;
	scummVM.hidden = YES;		
	
	//CREDITS
	creditsWebV.backgroundColor = [UIColor clearColor];
	creditsWebV.opaque = NO;
	creditsWebV.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath = [[NSBundle mainBundle] resourcePath];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error = nil;
	NSString *fullPath = [[NSBundle mainBundle] pathForResource:NSLocalizedString(@"CreditsURL", @"credits") ofType:@"html"];
	NSString *helpHtml = [NSString stringWithContentsOfFile:fullPath encoding:NSUTF8StringEncoding error:&error];
	
	[creditsWebV loadHTMLString:helpHtml baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath]]];
	
	creditsWebV.delegate = self;
	
	creditsWebV.hidden = NO;
	
	//LEGAL
	legalWebV.backgroundColor = [UIColor clearColor];
	legalWebV.opaque = NO;
	legalWebV.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath2 = [[NSBundle mainBundle] resourcePath];
	imagePath2 = [imagePath2 stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath2 = [imagePath2 stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error2 = nil;
	NSString *fullPath2 = [[NSBundle mainBundle] pathForResource:NSLocalizedString(@"LegalURL", @"legal") ofType:@"html"];
	NSString *helpHtml2 = [NSString stringWithContentsOfFile:fullPath2 encoding:NSUTF8StringEncoding error:&error2];
	
	[legalWebV loadHTMLString:helpHtml2 baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath2]]];
	
	legalWebV.delegate = self;	
	
	legalWebV.hidden = YES;	
	
	//GPL
	GPLWebV.backgroundColor = [UIColor clearColor];
	GPLWebV.opaque = NO;
	GPLWebV.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath3 = [[NSBundle mainBundle] resourcePath];
	imagePath3 = [imagePath3 stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath3 = [imagePath3 stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error3 = nil;
	NSString *fullPath3 = [[NSBundle mainBundle] pathForResource:@"gpl" ofType:@"html"];
	NSString *helpHtml3 = [NSString stringWithContentsOfFile:fullPath3 encoding:NSUTF8StringEncoding error:&error3];
	
	[GPLWebV loadHTMLString:helpHtml3 baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath3]]];
	
	GPLWebV.delegate = self;	
	
	GPLWebV.hidden = YES;		

	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
    [super viewDidLoad];	
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"creditsViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	bWarning = true;
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
	if( creditsWebV != nil )
	{
		[creditsWebV release];
		creditsWebV = nil;
	}
	if( activityIndicatorCWV != nil )
	{
		[activityIndicatorCWV release];
		activityIndicatorCWV = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"creditsViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	
	if( creditsWebV != nil )
	{
		[creditsWebV release];
		creditsWebV = nil;
	}
	if( legalWebV != nil )
	{
		[legalWebV release];
		legalWebV = nil;
	}	
	if( GPLWebV != nil )
	{
		[GPLWebV release];
		GPLWebV = nil;
	}	
	if( activityIndicatorCWV != nil )
	{
		[activityIndicatorCWV release];
		activityIndicatorCWV = nil;
	}	
}


- (void)dealloc 
{
	//NSLog(@"creditsViewController dealloc");	
    [super dealloc];
	
	if( creditsWebV != nil )
	{
		[creditsWebV release];
		creditsWebV = nil;
	}
	if( legalWebV != nil )
	{
		[legalWebV release];
		legalWebV = nil;
	}
	if( GPLWebV != nil )
	{
		[GPLWebV release];
		GPLWebV = nil;
	}	
	if( activityIndicatorCWV != nil )
	{
		[activityIndicatorCWV release];
		activityIndicatorCWV = nil;
	}
	
	if( nextP != nil )
	{
		[nextP release];
		nextP = nil;
	}	
	
	if( dotemuGPL != nil )
	{
		[dotemuGPL release];
		dotemuGPL = nil;
	}
	
	if( scummVM != nil )
	{
		[scummVM release];
		scummVM = nil;
	}
}


//anim finished
- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	if( !bWarning )
		;		
	else
		bWarning = false;
	
	/*if( creditsWebV != nil )
	 {
	 [creditsWebV release];
	 creditsWebV = nil;
	 }
	 if( legalWebV != nil )
	 {
	 [legalWebV release];
	 legalWebV = nil;
	 }
	 if( GPLWebV != nil )
	 {
	 [GPLWebV release];
	 GPLWebV = nil;
	 }	
	 if( activityIndicatorCWV != nil )
	 {
	 [activityIndicatorCWV release];
	 activityIndicatorCWV = nil;
	 }*/
	
	page = 0;
	creditsWebV.hidden = NO;
	legalWebV.hidden = YES;
	GPLWebV.hidden = YES;	
	
	dotemuGPL.hidden = YES;
	scummVM.hidden	 = YES;	
}

- (IBAction) nextPClicked:(id)sender
{
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if( page < 2 )
		page++;
	else
		page = 0;
	
	if( page == 0 )
	{
		creditsWebV.hidden = NO;
		legalWebV.hidden = YES;
		GPLWebV.hidden = YES;	
		
		dotemuGPL.hidden = YES;
		scummVM.hidden	 = YES;
	}
	else if( page == 1 )
	{
		creditsWebV.hidden = YES;
		legalWebV.hidden = NO;		
		GPLWebV.hidden = YES;
		
		dotemuGPL.hidden = NO;
		scummVM.hidden	 = NO;		
	}
	else
	{
		creditsWebV.hidden = YES;
		legalWebV.hidden = YES;		
		GPLWebV.hidden = NO;		
		
		dotemuGPL.hidden = YES;
		scummVM.hidden	 = YES;		
	}
}

-(IBAction) dotemuGPLClicked:(id)sender
{
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString: @"http://www.dotemu.com/gpl"]];	
}

-(IBAction) scummVMClicked:(id)sender
{
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString: @"http://www.scummvm.org"]];	
}

-(IBAction) menuClicked:(id)sender
{
	//NSLog(@"creditsViewController menuClicked");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"enableButtonMenuNotif" object:nil];	
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	//NSLog(@"creditsViewController webViewDidFinishLoad");
	[activityIndicatorCWV stopAnimating];
	activityIndicatorCWV.hidden = YES;	
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	//NSLog(@"creditsViewController webViewDidStartLoad");
	activityIndicatorCWV.hidden = NO;
	[activityIndicatorCWV startAnimating];
}


@end
