//
//  helpViewController.m
//  scummvm
//
//  Created by DotEmu on 18/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#import "switchViewController.h"
#import "helpViewController.h"
#import "Gob1MenuViewController.h"

extern int idSoundSFX;
extern int _GobLanguage;

@implementation helpViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"helpViewController viewDidLoad");
		
	bWarning = false;
	m_prevState.hidden = YES;
	m_nextState.hidden = NO;
	etatNext = 0;
	
	//clear
	[self removeBackground];
	
	//load
	//[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png")];
	[self loadPageOne];
	loadPage0 = true;
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
    [super viewDidLoad];	
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void) viewDidAppear:(BOOL)animated
{
	if( !loadPage0 )
		[self loadPageOne];
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"helpViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	bWarning = true;
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
	
	switch( etatNext )
	{
		case 0:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			[self removePageSix];
			break;
		case 1:
			[self removePageTwo];
			[self removePageThree];
			[self removePageSix];
			break;
		case 2:
			[self removePageOne];
			[self removePageThree];
			[self removePageSix];
			break;
		case 3:
			[self removePageOne];
			[self removePageTwo];
			[self removePageSix];
			break;
		case 4:
			[self removePageOne];
			[self removePageTwo];
			[self removePageThree];
			break;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"helpViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}
}


- (void)dealloc 
{
	//NSLog(@"helpViewController dealloc");	
	
	//actions
	if( m_menu != nil )
	{
		[m_menu release];
		m_menu = nil;
	}
	if( m_prevState != nil )
	{
		[m_prevState release];
		m_prevState = nil;
	}
	if( m_nextState != nil )
	{
		[m_nextState release];
		m_nextState = nil;
	}
	
	//background
	if( _layer != nil )
	{
		[_layer removeFromSuperview];
		[_layer release];
		_layer = nil;
	}
	if( fondV != nil )
	{
		[fondV removeFromSuperview];
		[fondV release];
		fondV = nil;
	}
	if( fond != nil )
	{
		[fond release];
		fond = nil;
	}
	
	//sound
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}

	//PAGE ZERO	
	if( scroll != nil )
	{
		[scroll release];
		scroll = nil;
	}
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}
	
	//PAGE ONE
	if( interfaceV != nil )
	{
		[interfaceV removeFromSuperview];
		[interfaceV release];
		interfaceV = nil;
	}
	if( markV != nil )
	{
		[markV removeFromSuperview];
		[markV release];
		markV = nil;
	}
	/*if( T1 != nil )
	{
		[T1 removeFromSuperview];
		[T1 release];
		T1 = nil;
	}
	if( T2 != nil )
	{
		[T2 removeFromSuperview];
		[T2 release];
		T2 = nil;
	}
	if( T3 != nil )
	{
		[T3 removeFromSuperview];
		[T3 release];
		T3 = nil;
	}
	if( T4 != nil )
	{
		[T4 removeFromSuperview];
		[T4 release];
		T4 = nil;
	}*/
	
	//PAGE ONE BIS
	if( I1 != nil )
	{
		[I1 removeFromSuperview];
		[I1 release];
		I1 = nil;
	}
	if( I2 != nil )
	{
		[I2 removeFromSuperview];
		[I2 release];
		I2 = nil;
	}
	if( I3 != nil )
	{
		[I3 removeFromSuperview];
		[I3 release];
		I3 = nil;
	}
	if( I4 != nil )
	{
		[I4 removeFromSuperview];
		[I4 release];
		I4 = nil;
	}
	if( TMenu != nil )
	{
		[TMenu removeFromSuperview];
		[TMenu release];
		TMenu = nil;
	}
	if( THints != nil )
	{
		[THints removeFromSuperview];
		[THints release];
		THints = nil;
	}
	if( TOpenMenu != nil )
	{
		[TOpenMenu removeFromSuperview];
		[TOpenMenu release];
		TOpenMenu = nil;
	}
	if( TFlag != nil )
	{
		[TFlag removeFromSuperview];
		[TFlag release];
		TFlag = nil;
	}
	
	//PAGE ONE TRES
	if( I5 != nil )
	{
		[I5 removeFromSuperview];
		[I5 release];
		I5 = nil;
	}
	if( I6 != nil )
	{
		[I6 removeFromSuperview];
		[I6 release];
		I6 = nil;
	}
	if( TGobliins != nil )
	{
		[TGobliins removeFromSuperview];
		[TGobliins release];
		TGobliins = nil;
	}
	if( TInventory != nil )
	{
		[TInventory removeFromSuperview];
		[TInventory release];
		TInventory = nil;
	}
	
	//PAGE TWO
	if( Theader != nil )
	{
		[Theader removeFromSuperview];
		[Theader release];
		Theader = nil;
	}
	if( Ttouch != nil )
	{
		[Ttouch removeFromSuperview];
		[Ttouch release];
		Ttouch = nil;
	}
	if( Tcursor != nil )
	{
		[Tcursor removeFromSuperview];
		[Tcursor release];
		Tcursor = nil;
	}
	
	//PAGES THREE
	if( Tdetails != nil )
	{
		[Tdetails removeFromSuperview];
		[Tdetails release];
		Tdetails = nil;
	}
	
	//PAGE FOUR
	if( icon1V != nil )
	{
		[icon1V removeFromSuperview];
		[icon1V release];
		icon1V = nil;
	}
	if( icon2V != nil )
	{
		[icon2V removeFromSuperview];
		[icon2V release];
		icon2V = nil;
	}
	if( icon3V != nil )
	{
		[icon3V removeFromSuperview];
		[icon3V release];
		icon3V = nil;
	}
	if( icon4V != nil )
	{
		[icon4V removeFromSuperview];
		[icon4V release];
		icon4V = nil;
	}	
	if( TSac != nil )
	{
		[TSac removeFromSuperview];
		[TSac release];
		TSac = nil;
	}
	if( THotspot != nil )
	{
		[THotspot removeFromSuperview];
		[THotspot release];
		THotspot = nil;
	}
	if( TPas != nil )
	{
		[TPas removeFromSuperview];
		[TPas release];
		TPas = nil;
	}
	if( TPorte != nil )
	{
		[TPorte removeFromSuperview];
		[TPorte release];
		TPorte = nil;
	}	
	
	[super dealloc];
}

- (void)autoscrollTimerFired:(NSTimer*)timer 
{
	CGPoint scrollPoint = scroll.contentOffset;
	scrollPoint = CGPointMake(scrollPoint.x, scrollPoint.y + 0.25);
	[scroll setContentOffset:scrollPoint animated:NO];
	
	if( _GobLanguage == 0 )
	{
		if( scrollPoint.y >= 550 )
			scroll.contentOffset = CGPointMake( 0, 0 );			
	}
	else if( _GobLanguage == 1 )
	{
		if( scrollPoint.y >= 600 )
			scroll.contentOffset = CGPointMake( 0, 0 );	
	}
}

-(void) loadPageZero
{
	[_layer setImage:[UIImage imageNamed:@"help_fond.png"]];
	
	generalWebV.backgroundColor = [UIColor clearColor];
	generalWebV.opaque = NO;
	generalWebV.dataDetectorTypes = UIDataDetectorTypeNone;
	
	NSString *imagePath = [[NSBundle mainBundle] resourcePath];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@"/" withString:@"//"];
	imagePath = [imagePath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
	
	NSError *error = nil;
	NSString *fullPath = [[NSBundle mainBundle] pathForResource:NSLocalizedString(@"HelpURL", @"help-general") ofType:@"html"];
	NSString *helpHtml = [NSString stringWithContentsOfFile:fullPath encoding:NSUTF8StringEncoding error:&error];
	
	[generalWebV loadHTMLString:helpHtml baseURL:[NSURL URLWithString: [NSString stringWithFormat:@"file:/%@//",imagePath]]];
	
	generalWebV.hidden = NO;
	//activityIndicatorGWV.hidden = NO;
	
	generalWebV.delegate = self;
	[self.view insertSubview:generalWebV aboveSubview:fondV];
	[self.view insertSubview:activityIndicatorGWV aboveSubview:fondV];
	
	scroll.hidden = NO;	
	[scroll addSubview:generalWebV];	
	[scroll setContentOffset:CGPointMake(0, 0)];
	
	if( _GobLanguage == 0 )
		[scroll setContentSize:CGSizeMake( 440, 550 )];
	else if( _GobLanguage == 1 )
		[scroll setContentSize:CGSizeMake( 440, 600 )];
	
	/*if (autoscrollTimer != nil) 
	{
		[autoscrollTimer invalidate];
		autoscrollTimer = nil;
	}
	
	if (autoscrollTimer == nil) 
	{
		autoscrollTimer = [NSTimer scheduledTimerWithTimeInterval:(55.0/1000.0)
														   target:self
														 selector:@selector(autoscrollTimerFired:) 
														 userInfo:nil 
														  repeats:YES];
	}*/
}
								 
-(void) removePageZero
{	
	loadPage0 = false;
	if( autoscrollTimer != nil )
	{
		[autoscrollTimer invalidate];
		autoscrollTimer = nil;
	}
	/*if( scroll != nil )
	{
		[scroll release];
		scroll = nil;
	}
	if( generalWebV != nil )
	{
		[generalWebV release];
		generalWebV = nil;
	}
	if( activityIndicatorGWV != nil )
	{
		[activityIndicatorGWV release];
		activityIndicatorGWV = nil;
	}*/
}

-(void) loadPageOne
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;	
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	interfaceV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:@"help-interface.png"] retain];		
	[interfaceV setImage:gob];		
	[gob release];		
	[self.view addSubview:interfaceV];
	[self.view insertSubview:m_menu aboveSubview:interfaceV];
	[self.view insertSubview:m_nextState aboveSubview:interfaceV];
	[self.view insertSubview:m_prevState aboveSubview:interfaceV];
	
	/*T1 = [[UITextView alloc ] initWithFrame:CGRectMake( 106, 47, 330, 100 )];
	T1.backgroundColor = [UIColor clearColor];
	T1.textColor = [UIColor whiteColor];	
	T1.font = [UIFont fontWithName:@"Verdana" size:12];
	T1.scrollEnabled = NO;
	T1.editable = NO;
	T1.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	T1.text = @"Menu";
	[T1 setUserInteractionEnabled:NO];
	[self.view addSubview:T1];	
	
	if( _GobLanguage == 0 )
		T2 = [[UITextView alloc ] initWithFrame:CGRectMake( 359, 64, 330, 100 )];
	else if( _GobLanguage == 1 )
		T2 = [[UITextView alloc ] initWithFrame:CGRectMake( 352, 64, 330, 100 )];
	
	T2.backgroundColor = [UIColor clearColor];
	T2.textColor = [UIColor whiteColor];	
	T2.font = [UIFont fontWithName:@"Verdana" size:12];
	T2.scrollEnabled = NO;
	T2.editable = NO;
	T2.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	T2.text = NSLocalizedString(@"Help1.2Text", @"Hints");
	[T2 setUserInteractionEnabled:NO];	
	[self.view addSubview:T2];	
	
	T3 = [[UITextView alloc ] initWithFrame:CGRectMake( 334, 213, 330, 100 )];
	T3.backgroundColor = [UIColor clearColor];
	T3.textColor = [UIColor whiteColor];	
	T3.font = [UIFont fontWithName:@"Verdana" size:12];
	T3.scrollEnabled = NO;
	T3.editable = NO;
	T3.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	T3.text = NSLocalizedString(@"Help1.3Text", @"Inventory");
	[T3 setUserInteractionEnabled:NO];	
	[self.view addSubview:T3];
	
	if( _GobLanguage == 0 )
		T4 = [[UITextView alloc ] initWithFrame:CGRectMake( 77, 214, 330, 100 )];
	else if( _GobLanguage == 1 )
		T4 = [[UITextView alloc ] initWithFrame:CGRectMake( 74, 214, 330, 100 )];		
	T4.backgroundColor = [UIColor clearColor];
	T4.textColor = [UIColor whiteColor];	
	T4.font = [UIFont fontWithName:@"Verdana" size:12];
	T4.scrollEnabled = NO;
	T4.editable = NO;
	T4.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	T4.text = NSLocalizedString(@"Help1.4Text", @"Scenes");
	[T4 setUserInteractionEnabled:NO];	
	[self.view addSubview:T4];
	
	[self.view insertSubview:T1 aboveSubview:interfaceV];
	[self.view insertSubview:T2 aboveSubview:interfaceV];
	[self.view insertSubview:T3 aboveSubview:interfaceV];
	[self.view insertSubview:T4 aboveSubview:interfaceV];*/
}

-(void) removePageOne
{
	if( interfaceV != nil )
	{
		[interfaceV removeFromSuperview];
		[interfaceV release];	
		interfaceV = nil;
	}
	
	/*if( T1 != nil )
	{
		[T1 removeFromSuperview];
		[T1 release];			
		T1 = nil;
	}
	if( T2 != nil )
	{
		[T2 removeFromSuperview];
		[T2 release];			
		T2 = nil;
	}
	if( T3 != nil )
	{
		[T3 removeFromSuperview];
		[T3 release];			
		T3 = nil;
	}
	if( T4 != nil )
	{
		[T4 removeFromSuperview];
		[T4 release];			
		T4 = nil;
	}*/
	m_menu.hidden = NO;	
}

- (void) loadPageOneBis
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	I1 = [[UIImageView alloc] initWithFrame:CGRectMake(50, 82, 59, 36)];		
	UIImage* gob = [[UIImage imageNamed:@"openMenuBar.png"] retain];		
	[I1 setImage:gob];		
	[gob release];		
	[self.view addSubview:I1];
	
	TOpenMenu = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 75, 350, 100 )];
	TOpenMenu.textColor = [UIColor whiteColor];
	TOpenMenu.backgroundColor = [UIColor clearColor];
	TOpenMenu.font = [UIFont fontWithName:@"Verdana" size:12];
	TOpenMenu.scrollEnabled = NO;
	TOpenMenu.editable = NO;
	TOpenMenu.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TOpenMenu.text = NSLocalizedString(@"Help1b.1Text", @"This button will allow you to open the menu bar where you will find a lot of settings.");
	[TOpenMenu setUserInteractionEnabled:NO];	
	[self.view addSubview:TOpenMenu];
	
	I2 = [[UIImageView alloc] initWithFrame:CGRectMake(43, 136, 73, 36)];		
	gob = [[UIImage imageNamed:@"menu_ingame.png"] retain];		
	[I2 setImage:gob];		
	[gob release];		
	[self.view addSubview:I2];
	
	TMenu = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 122, 350, 100 )];
	TMenu.textColor = [UIColor whiteColor];
	TMenu.backgroundColor = [UIColor clearColor];
	TMenu.font = [UIFont fontWithName:@"Verdana" size:12];
	TMenu.scrollEnabled = NO;
	TMenu.editable = NO;
	TMenu.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TMenu.text = NSLocalizedString(@"Help1b.2Text", @"In the menu, you will be able to save your progression or load another one, change the settings or get back to the main menu.");
	[TMenu setUserInteractionEnabled:NO];	
	[self.view addSubview:TMenu];
	
	I3 = [[UIImageView alloc] initWithFrame:CGRectMake(40, 188, 75, 36)];	
	if( _GobLanguage == 0 )
	{
		gob = [[UIImage imageNamed:@"hint_ingame.png"] retain];		
		[I3 setImage:gob];		
		[gob release];		
	}
	else if( _GobLanguage == 1 )
	{
		gob = [[UIImage imageNamed:@"hint_fr_ingame.png"] retain];		
		[I3 setImage:gob];		
		[gob release];		
	}
	[self.view addSubview:I3];
	
	THints = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 183, 350, 100 )];
	THints.textColor = [UIColor whiteColor];
	THints.backgroundColor = [UIColor clearColor];
	THints.font = [UIFont fontWithName:@"Verdana" size:12];
	THints.scrollEnabled = NO;
	THints.editable = NO;
	THints.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	THints.text = NSLocalizedString(@"Help1b.3Text", @"The hints will help you find the best strategy to resolve the scenes of the world you are in.");
	[THints setUserInteractionEnabled:NO];	
	[self.view addSubview:THints];
	
	
	I4 = [[UIImageView alloc] initWithFrame:CGRectMake(33, 238, 79, 36)];
	if( _GobLanguage == 0 )
	{	
		gob = [[UIImage imageNamed:@"flag.png"] retain];		
		[I4 setImage:gob];		
		[gob release];		
	}
	else if( _GobLanguage == 1 )
	{
		gob = [[UIImage imageNamed:@"flag_fr.png"] retain];		
		[I4 setImage:gob];		
		[gob release];		
	}
	[self.view addSubview:I4];
	
	TFlag = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 232, 350, 50 )];
	TFlag.textColor = [UIColor whiteColor];
	TFlag.backgroundColor = [UIColor clearColor];
	TFlag.font = [UIFont fontWithName:@"Verdana" size:12];
	TFlag.scrollEnabled = NO;
	TFlag.editable = NO;
	TFlag.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TFlag.text = NSLocalizedString(@"Help1b.4Text", @"« Move to » will allow you to go to another scene of your current world.");
	[TFlag setUserInteractionEnabled:NO];	
	[self.view addSubview:TFlag];
}

-(void) removePageOneBis
{
	if( I1 != nil )
	{
		[I1 removeFromSuperview];
		[I1 release];
		I1 = nil;
	}
	if( I2 != nil )
	{
		[I2 removeFromSuperview];
		[I2 release];		
		I2 = nil;
	}
	if( I3 != nil )
	{
		[I3 removeFromSuperview];
		[I3 release];		
		I3 = nil;
	}	
	if( I4 != nil )
	{
		[I4 removeFromSuperview];
		[I4 release];		
		I4 = nil;
	}		
	if( TOpenMenu != nil )
	{
		[TOpenMenu removeFromSuperview];
		[TOpenMenu release];		
		TOpenMenu = nil;
	}
	if( TMenu != nil )
	{
		[TMenu removeFromSuperview];
		[TMenu release];		
		TMenu = nil;
	}
	if( THints != nil )
	{
		[THints removeFromSuperview];
		[THints release];			
		THints = nil;
	}
	if( TFlag != nil )
	{
		[TFlag removeFromSuperview];
		[TFlag release];			
		TFlag = nil;
	}	
}

- (void) loadPageOneTres
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	I5 = [[UIImageView alloc] initWithFrame:CGRectMake(50, 85, 60, 60)];		
	UIImage* gob = [[UIImage imageNamed:@"fingus.png"] retain];		
	[I5 setImage:gob];		
	[gob release];		
	[self.view addSubview:I5];
	
	TGobliins = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 95, 350, 100 )];
	TGobliins.textColor = [UIColor whiteColor];
	TGobliins.backgroundColor = [UIColor clearColor];
	TGobliins.font = [UIFont fontWithName:@"Verdana" size:12];
	TGobliins.scrollEnabled = NO;
	TGobliins.editable = NO;
	TGobliins.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TGobliins.text = NSLocalizedString(@"Help1c.1Text", @"This button will allow you to switch your gobliin in order to make an action faster.");
	[TGobliins setUserInteractionEnabled:NO];	
	[self.view addSubview:TGobliins];
	
	I6 = [[UIImageView alloc] initWithFrame:CGRectMake(60, 173, 46, 46)];		
	gob = [[UIImage imageNamed:@"sacadosclose.png"] retain];		
	[I6 setImage:gob];		
	[gob release];		
	[self.view addSubview:I6];
	
	TInventory = [[UITextView alloc ] initWithFrame:CGRectMake( 120, 165, 350, 100 )];
	TInventory.textColor = [UIColor whiteColor];
	TInventory.backgroundColor = [UIColor clearColor];
	TInventory.font = [UIFont fontWithName:@"Verdana" size:12];
	TInventory.scrollEnabled = NO;
	TInventory.editable = NO;
	TInventory.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TInventory.text = NSLocalizedString(@"Help1c.2Text", @"In the inventory you will find the objects you get during the game. Click on the bag and then select an object to use it.");
	[TInventory setUserInteractionEnabled:NO];	
	[self.view addSubview:TInventory];	
}

-(void) removePageOneTres
{
	if( I5 != nil )
	{
		[I5 removeFromSuperview];
		[I5 release];
		I5 = nil;
	}
	if( I6 != nil )
	{
		[I6 removeFromSuperview];
		[I6 release];		
		I6 = nil;
	}
	
	if( TGobliins != nil )
	{
		[TGobliins removeFromSuperview];
		[TGobliins release];		
		TGobliins = nil;
	}
	if( TInventory != nil )
	{
		[TInventory removeFromSuperview];
		[TInventory release];		
		TInventory = nil;
	}	
}

-(void) loadPageTwo
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;	
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	if( _GobLanguage == 0 )
		Theader = [[UITextView alloc] initWithFrame:CGRectMake( 108, 75, 400, 50 )];
	else if( _GobLanguage == 1 )
		Theader = [[UITextView alloc] initWithFrame:CGRectMake( 90, 75, 400, 50 )];
	Theader.textColor = [UIColor whiteColor];
	Theader.backgroundColor = [UIColor clearColor];
	Theader.font = [UIFont fontWithName:@"Verdana" size:20];
	Theader.font = [UIFont boldSystemFontOfSize:20];
	Theader.scrollEnabled = NO;
	Theader.editable = NO;
	Theader.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	Theader.text = NSLocalizedString(@"Help2.1Text", @"Be as precise as possible!");
	[Theader setUserInteractionEnabled:NO];	
	[self.view addSubview:Theader];
	
	Ttouch = [[UITextView alloc ] initWithFrame:CGRectMake( 45, 120, 395, 100 )];
	Ttouch.textColor = [UIColor whiteColor];	
	Ttouch.backgroundColor = [UIColor clearColor];
	Ttouch.font = [UIFont fontWithName:@"Verdana" size:12];
	Ttouch.scrollEnabled = NO;
	Ttouch.editable = NO;
	Ttouch.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	Ttouch.text = NSLocalizedString(@"Help2.2Text", @"1) A cursor will allow you to reach unattainable areas of the scene. Keep your finger on the screen and drag the cursor to the wanted area. Then click to confirm the action (move or use).");
	[Ttouch setUserInteractionEnabled:NO];	
	[self.view addSubview:Ttouch];	
	
	Tcursor = [[UITextView alloc ] initWithFrame:CGRectMake( 45, 200, 395, 100 )];
	Tcursor.textColor = [UIColor whiteColor];
	Tcursor.backgroundColor = [UIColor clearColor];
	Tcursor.font = [UIFont fontWithName:@"Verdana" size:12];
	Tcursor.scrollEnabled = NO;
	Tcursor.editable = NO;
	Tcursor.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	Tcursor.text = NSLocalizedString(@"Help2.3Text", @"2) Don't lose the action thanks to the icons in the cursor. Read more about that in the following help.");
	[Tcursor setUserInteractionEnabled:NO];	
	[self.view addSubview:Tcursor];	
}

-(void) removePageTwo
{
	if( Theader != nil )
	{
		[Theader removeFromSuperview];
		[Theader release];
		Theader = nil;
	}
	if( Ttouch != nil )
	{
		[Ttouch removeFromSuperview];
		[Ttouch release];		
		Ttouch = nil;
	}
	if( Tcursor != nil )
	{
		[Tcursor removeFromSuperview];
		[Tcursor release];		
		Tcursor = nil;
	}
}

-(void) loadPageSix
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;	
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	icon1V = [[UIImageView alloc] initWithFrame:CGRectMake(50, 65, 40, 40)];		
	UIImage* gob = [[UIImage imageNamed:@"curpas.png"] retain];		
	[icon1V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon1V];
	
	TPas = [[UITextView alloc ] initWithFrame:CGRectMake( 100, 65, 380, 100 )];
	TPas.textColor = [UIColor whiteColor];
	TPas.backgroundColor = [UIColor clearColor];
	TPas.font = [UIFont fontWithName:@"Verdana" size:12];
	TPas.scrollEnabled = NO;
	TPas.editable = NO;
	TPas.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TPas.text = NSLocalizedString(@"Help6.1Text", @"This cursor is the default one. It indicates that you can move your gobliin at the position of the cursor.");
	[TPas setUserInteractionEnabled:NO];	
	[self.view addSubview:TPas];	
	
	icon2V = [[UIImageView alloc] initWithFrame:CGRectMake(50, 115, 40, 40)];		
	gob = [[UIImage imageNamed:@"curexclamation.png"] retain];		
	[icon2V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon2V];
	
	THotspot = [[UITextView alloc ] initWithFrame:CGRectMake( 100, 110, 380, 100 )];
	THotspot.textColor = [UIColor whiteColor];
	THotspot.backgroundColor = [UIColor clearColor];
	THotspot.font = [UIFont fontWithName:@"Verdana" size:12];
	THotspot.scrollEnabled = NO;
	THotspot.editable = NO;
	THotspot.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	THotspot.text = NSLocalizedString(@"Help6.2Text", @"The exclamation mark represents hotspots. When this cursor appears, it means you can interact with the area you are on.");
	[THotspot setUserInteractionEnabled:NO];	
	[self.view addSubview:THotspot];	
	
	icon3V = [[UIImageView alloc] initWithFrame:CGRectMake(50, 175, 40, 40)];		
	gob = [[UIImage imageNamed:@"cursac.png"] retain];		
	[icon3V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon3V];
	
	TSac = [[UITextView alloc ] initWithFrame:CGRectMake( 100, 170, 380, 100 )];
	TSac.textColor = [UIColor whiteColor];
	TSac.backgroundColor = [UIColor clearColor];
	TSac.font = [UIFont fontWithName:@"Verdana" size:12];
	TSac.scrollEnabled = NO;
	TSac.editable = NO;
	TSac.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TSac.text = NSLocalizedString(@"Help6.3Text", @"When you see this cursor, it means you have an object in hand. A text regarding that will also be displayed at the bottom left. Just move your cursor and tap on the screen to use the object on the area pointed.");
	[TSac setUserInteractionEnabled:NO];	
	[self.view addSubview:TSac];
	
	icon4V = [[UIImageView alloc] initWithFrame:CGRectMake(50, 245, 40, 40)];		
	gob = [[UIImage imageNamed:@"curdoor.png"] retain];		
	[icon4V setImage:gob];		
	[gob release];		
	[self.view addSubview:icon4V];
	
	TPorte = [[UITextView alloc ] initWithFrame:CGRectMake( 100, 245, 380, 100 )];
	TPorte.textColor = [UIColor whiteColor];
	TPorte.backgroundColor = [UIColor clearColor];
	TPorte.font = [UIFont fontWithName:@"Verdana" size:12];
	TPorte.scrollEnabled = NO;
	TPorte.editable = NO;
	TPorte.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	TPorte.text = NSLocalizedString(@"Help6.4Text", @"When a door appears in your cursor, it means you're going to another scene.");
	[TPorte setUserInteractionEnabled:NO];	
	[self.view addSubview:TPorte];
}

-(void) removePageSix
{
	if( icon1V != nil )
	{
		[icon1V removeFromSuperview];
		[icon1V release];
		icon1V = nil;
	}
	if( icon2V != nil )
	{
		[icon2V removeFromSuperview];
		[icon2V release];		
		icon2V = nil;
	}
	if( icon3V != nil )
	{
		[icon3V removeFromSuperview];
		[icon3V release];		
		icon3V = nil;
	}	
	if( icon4V != nil )
	{
		[icon4V removeFromSuperview];
		[icon4V release];		
		icon4V = nil;
	}
	if( TPas != nil )
	{
		[TPas removeFromSuperview];
		[TPas release];		
		TPas = nil;
	}
	if( THotspot != nil )
	{
		[THotspot removeFromSuperview];
		[THotspot release];			
		THotspot = nil;
	}
	if( TSac != nil )
	{
		[TSac removeFromSuperview];
		[TSac release];			
		TSac = nil;
	}
	if( TPorte != nil )
	{
		[TPorte removeFromSuperview];
		[TPorte release];			
		TPorte = nil;
	}
}

-(void) loadPageThree
{
	[_layer setImage:[UIImage imageNamed:@"help_fond_bis.png"]];	
	scroll.hidden = YES;	
	generalWebV.hidden = YES;
	activityIndicatorGWV.hidden = YES;
	
	interfaceV = [[UIImageView alloc] initWithFrame:CGRectMake(30, 20, 420, 280)];		
	UIImage* gob = [[UIImage imageNamed:NSLocalizedString(@"HelpImgHotspots", @"help-hotspots.png")] retain];		
	[interfaceV setImage:gob];		
	[gob release];		
	[self.view addSubview:interfaceV];
	[self.view insertSubview:m_menu aboveSubview:interfaceV];
	[self.view insertSubview:m_nextState aboveSubview:interfaceV];
	[self.view insertSubview:m_prevState aboveSubview:interfaceV];
	
	Tdetails = [[UITextView alloc ] initWithFrame:CGRectMake( 312, 70, 135, 175 )];
	Tdetails.textColor = [UIColor whiteColor];
	Tdetails.backgroundColor = [UIColor clearColor];
	Tdetails.font = [UIFont fontWithName:@"Verdana" size:10];
	Tdetails.scrollEnabled = NO;
	Tdetails.editable = NO;
	Tdetails.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	Tdetails.text = NSLocalizedString(@"Help3Text", @"The hotspots (   ) are the spots of the scene you can interact with.\n\nIt helps you to know where an action can be made.\n\nJust drag the cursor on the scene to display them.");
	[Tdetails setUserInteractionEnabled:NO];	
	[self.view addSubview:Tdetails];
	[self.view insertSubview:Tdetails aboveSubview:interfaceV];
	
	if( _GobLanguage == 0 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake(396, 81, 10, 10)];		
	else if( _GobLanguage == 1 )
		markV = [[UIImageView alloc] initWithFrame:CGRectMake(407, 81, 10, 10)];		
	gob = [[UIImage imageNamed:@"rond bleu.png"] retain];		
	[markV setImage:gob];		
	[gob release];		
	[self.view addSubview:markV];
}

-(void) removePageThree
{
	if( interfaceV != nil )
	{
		[interfaceV removeFromSuperview];
		[interfaceV release];			
		interfaceV = nil;
	}
	if( markV != nil )
	{
		[markV removeFromSuperview];
		[markV release];			
		markV = nil;
	}
	if( Tdetails != nil )
	{
		[Tdetails removeFromSuperview];
		[Tdetails release];			
		Tdetails = nil;
	}
	m_menu.hidden = NO;
}

-(void) loadBackground:(NSString*)background
{
	fondV = [[UIImageView alloc] initWithFrame:CGRectMake(130, 25, 224, 36)];		
	fond = [[UIImage imageNamed:background] retain];		
	[fondV setImage:fond];		
	[fond release];		
	[self.view addSubview:fondV];
	
	[self.view insertSubview:m_menu aboveSubview:fondV];
	[self.view insertSubview:m_nextState aboveSubview:fondV];
	[self.view insertSubview:m_prevState aboveSubview:fondV];
}

-(void) removeBackground
{
	if( fondV != nil )
	{
		[fondV removeFromSuperview];
		[fondV release];		
		fondV = nil;
	}
}

//anim finished
- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	[self.view removeFromSuperview];
	if( !bWarning )
		;		
	else
		bWarning = false;
	
	//clear
	[self removeBackground];
	[self removePageZero];
	[self removePageOne];
	[self removePageOneBis];
	[self removePageOneTres];	
	[self removePageTwo];
	[self removePageThree];
	[self removePageSix];
	etatNext = 0;
	m_prevState.hidden = YES;
	m_nextState.hidden = NO;
}

-(IBAction) menuClicked:(id)sender
{
	//NSLog(@"helpViewController menuClicked");	
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"enableButtonMenuNotif" object:nil];
}

-(IBAction) nextClicked:(id)sender
{
	//NSLog(@"helpViewController nextClicked");		
	etatNext++;
	
	//clear
	[self removeBackground];
	[self removePageZero];		
	[self removePageOne];
	[self removePageOneBis];
	[self removePageOneTres];	
	[self removePageTwo];
	[self removePageThree];
	[self removePageSix];
	
	switch( etatNext )
	{
		case 0:
			m_prevState.hidden = YES;
			m_nextState.hidden = NO;
			//load
			[self loadPageOne];
			break;
		case 1:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:@"help-interface_title.png"];			
			[self loadPageOneBis];
			break;
		case 2:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:@"help-interface_title.png"];			
			[self loadPageOneTres];
			break;
		case 3:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgControl", @"help-control.png") ];
			[self loadPageTwo];
			break;	
		case 4:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThree];
			break;
		case 5:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgCursors", @"help-cursors.png") ];
			[self loadPageSix];
			break;
		case 6:
			m_prevState.hidden = NO;
			m_nextState.hidden = YES;
			[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
			[self loadPageZero];
			break;			
	}

	
	if( etatNext > 0 )
		m_prevState.hidden = NO;
	if( etatNext == 6 )
		m_nextState.hidden = YES;
}

-(IBAction) prevClicked:(id)sender
{
	//NSLog(@"helpViewController prevClicked");			
	etatNext--;
	
	//clear
	[self removeBackground];
	[self removePageZero];	
	[self removePageOne];
	[self removePageOneBis];
	[self removePageOneTres];	
	[self removePageTwo];
	[self removePageThree];
	[self removePageSix];
	
	switch( etatNext )
	{
		case 0:
			m_prevState.hidden = YES;
			m_nextState.hidden = NO;
			//load
			[self loadPageOne];
			break;
		case 1:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:@"help-interface_title.png"];			
			[self loadPageOneBis];
			break;
		case 2:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:@"help-interface_title.png"];			
			[self loadPageOneTres];
			break;
		case 3:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgControl", @"help-control.png") ];
			[self loadPageTwo];
			break;	
		case 4:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadPageThree];
			break;
		case 5:
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;
			//load
			[self loadBackground:NSLocalizedString(@"HelpImgCursors", @"help-cursors.png") ];
			[self loadPageSix];
			break;
		case 6:
			m_prevState.hidden = NO;
			m_nextState.hidden = YES;
			[self loadBackground:NSLocalizedString(@"HelpImgGeneral", @"help-general.png") ];
			[self loadPageZero];
			break;			
	}
	
	if( etatNext == 0 )
	{
		m_prevState.hidden = YES;
		m_nextState.hidden = NO;
	}
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	//NSLog(@"helpViewController webViewDidFinishLoad");
	if( etatNext == 0 )
	{
		[activityIndicatorGWV stopAnimating];
		activityIndicatorGWV.hidden = YES;
	}
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	//NSLog(@"helpViewController webViewDidStartLoad");
	if( etatNext == 0 )
	{
		activityIndicatorGWV.hidden = NO;
		[activityIndicatorGWV startAnimating];
	}
}

@end
